#Author : Rieux Charlotte, University of Nantes, France
#!/usr/bin/env bash

##############################################################################
## HEATMAP COLUMNS ORDERING
##############################################################################

rownb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap.csv | wc -l | cut -f1)
colnb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | wc -l | cut -f1)
i=1

order=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/col_leaves_order.csv | sed 's/"//g'| sed 's/,/\n/g' | sort)

while [ $i -le $(($rownb-1)) ]; do

	cpd=$(echo $order | cut -d " " -f $i)
	#echo $cpd
	cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap.csv | grep "\"$cpd\"" >> temp.txt
	i=$(($i+1))

done 

cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap.csv | tail -n 1 >> temp.txt

sed -i 's/,/ /g' temp.txt 

row=$(wc -l temp.txt | cut -d " " -f 1)
column=$(head -n 1 temp.txt | tail -n 1 | awk '{print NF}')
cat temp.txt > "#temp.txt#"
rm temp.txt
i=1
j=0

while [ $i -le $column ]; do
	while [ $j -le $row ]; do
		value=$(head -n $j "#temp.txt#" | tail -n 1 | awk '{print $'"$i"'}')
		echo -n "$value " >> temp.txt
		j=$(($j+1))
	done
	echo "" >> temp.txt
	j=0
	i=$(($i+1))
done

cat temp.txt > /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
sed -i 's/ /,/g' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
sed -i -e 's/^.//' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
rm temp.txt
rm "#temp.txt#"

i=1

order=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/row_leaves_order.csv) 

cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | head -n 1 | tail -n 1 > temp.txt

while [ $i -le $(($colnb-1)) ]; do
	target=$(echo $order | cut -d "," -f $i)
	#echo $target
	cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | grep "$target" >> temp.txt
	i=$(($i+1))
done

sed -i 's/,/ /g' temp.txt 

row=$(wc -l temp.txt | cut -d " " -f 1)
column=$(head -n 1 temp.txt | tail -n 1 | awk '{print NF}')
cat temp.txt > "#temp.txt#"
rm temp.txt
i=1
j=0

while [ $i -le $column ]; do
	while [ $j -le $row ]; do
		value=$(head -n $j "#temp.txt#" | tail -n 1 | awk '{print $'"$i"'}')
		echo -n "$value " >> temp.txt
		j=$(($j+1))
	done
	echo "" >> temp.txt
	j=0
	i=$(($i+1))
done

cat temp.txt > /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
sed -i 's/ /,/g' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
sed -i -e 's/^.//' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
sed -i -e 's/.$//' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv
rm temp.txt
rm "#temp.txt#"

##############################################################################
## DATA
##############################################################################

rownb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | wc -l | cut -f1)
colnb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | wc -l | cut -f1)
totalcount=""
i=2
leaf=1

echo -en "{\n\t\"data\" :{\n\n\t\t\"nodes\": {\n" > inch_mol_input.json

while [ $i -le $rownb ]; do 

	line=$(head -n $i /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | tail -n 1)
	#echo $line
	id=$(echo $line | cut -d "," -f1)
	#echo -e $id
	leaf1=$(echo $line | cut -d "," -f2)
	#echo $leaf1
	leaf2=$(echo $line | cut -d "," -f3)
	#echo $leaf2
	height=0
	#echo $height
	parentline=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | cut -d "," -f2,3 | grep -n $id | cut -d ":" -f1)
	#echo $parentline
	count=0

	if [[ $leaf1 =~ "leaf" ]]; then
		leaf=$(echo $leaf1 | cut -d "_" -f2 | cut -d "\"" -f1)
		#echo $leaf
		object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | cut -d "," -f 1 | head -n $leaf | tail -n 1)
		#leaf=$(($leaf+1))
		#echo $object_id		
		features=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | grep $object_id | cut -d "," -f 2-)
		#echo $features
		echo -en "\n\t\t\t$leaf1: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"features\": [$features],\n\t\t\t\t\"parent\": $id,\n\t\t\t\t\"objects\": [$object_id]\n\t\t\t}," >> inch_mol_input.json	
		count=1

		if [[ $leaf2 =~ "leaf" ]]; then
			leaf=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | cut -d "," -f 1 | head -n $leaf | tail -n 1)	
			#leaf=$(($leaf+1))
			features=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | grep $object_id | cut -d "," -f 2-)
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"features\": [$features],\n\t\t\t\t\"parent\": $id,\n\t\t\t\t\"objects\": [$object_id]\n\t\t\t}," >> inch_mol_input.json		
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))				
		fi

	else

		if [[ $leaf2 =~ "leaf" ]]; then
			leaf=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | cut -d "," -f 1 | head -n $leaf | tail -n 1)
			#leaf=$(($leaf+1))
			features=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | grep $object_id | cut -d "," -f 2-)
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"features\": [$features],\n\t\t\t\t\"parent\": $id,\n\t\t\t\t\"objects\": [$object_id]\n\t\t\t}," >> inch_mol_input.json		
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))
		fi

		node=$(echo $leaf1 | cut -d "_" -f2 | cut -d "\"" -f1)
		leaves=$(echo "$totalcount" | cut -d "," -f $node)
		count=$(($count+$leaves))
	fi

	if [[ $id =~ "\"node_1\"" ]]; then
		totalcount=$(echo "$count")
	else
		totalcount=$(echo "$totalcount,$count")
	fi
	#echo $totalcount

	height=$(echo $line | cut -d "," -f4 | cut -d "\"" -f2)

	if [[ $parentline =~ [0-9]+ ]]; then
		parent=$(head -n $parentline /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | tail -n 1 | cut -d "," -f1)
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"parent\": $parent,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}," >> inch_mol_input.json	
	else
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}" >> inch_mol_input.json	
	fi
	
	i=$(($i+1))
done

feature_names=$(head -n 1 /usr/lib/knime_2.9.2/workspace/drop/Tables/row_leaves_order.csv | tail -n 1)
echo -en "\n\t\t},\n\n\t\t\"feature_names\": [$feature_names]\n\t}," >> inch_mol_input.json

##############################################################################
## METADATA
##############################################################################

i=2
leaf=1

echo -en "\n\n\t\"metadata\": {\n\t\t\"feature_names\": [\"Input\"],\n\t\t\"nodes\": {" >> inch_mol_input.json

while [ $i -le $(($rownb+1)) ]; do 
	compound=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_mol.csv | cut -d "," -f 1 | head -n $leaf | tail -n 1)
	#echo $compound

	if [[ $compound =~ CHEMBL[0-9]* ]]; then		
		input_bool=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/compounds.csv | grep $compound | cut -d "," -f 2)
	else
		#echo "yes"
		compound=$(echo $compound | sed 's/\"//g')
		compound=$(echo "\"X$compound\"")
		input_bool=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/compounds.csv | grep $compound | cut -d "," -f 2)
	fi

	#echo $input_bool

	if [[ $input_bool =~ "1" ]]; then
		input_bool="Input"
	else 
		input_bool="Similar"
	fi

	if [ $i -eq $(($rownb+1)) ]; then
		echo -en "\n\t\t\t\"leaf_$leaf\" : [\"$input_bool\"]" >> inch_mol_input.json
	else
		echo -en "\n\t\t\t\"leaf_$leaf\" : [\"$input_bool\"]," >> inch_mol_input.json
	fi
	leaf=$(($leaf+1))	
	i=$(($i+1))

done

echo -en "\n\t\t}\n\t}," >> inch_mol_input.json

##############################################################################
## COLUMN DENDROGRAM
##############################################################################

i=2
totalcount=""
echo -en "\n\n\t\"column_dendrogram\": {\n\t\t \"nodes\": {" >> inch_mol_input.json

while [ $i -le $colnb ]; do 

	line=$(head -n $i /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | tail -n 1)
	#echo $line
	id=$(echo $line | cut -d "," -f1)
	#echo -e $id
	leaf1=$(echo $line | cut -d "," -f2)
	#echo $leaf1
	leaf2=$(echo $line | cut -d "," -f3)
	#echo $leaf2
	height=0
	#echo $height
	parentline=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | cut -d "," -f2,3 | grep -n $id | cut -d ":" -f1)
	#echo $parentline
	count=0

	if [[ $leaf1 =~ "leaf" ]]; then
		echo -en "\n\t\t\t$leaf1: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"parent\": $id \n\t\t\t}," >> inch_mol_input.json	
		count=1

		if [[ $leaf2 =~ "leaf" ]]; then
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"parent\": $id \n\t\t\t}," >> inch_mol_input.json	
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))				
		fi

	else

		if [[ $leaf2 =~ "leaf" ]]; then
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"parent\": $id \n\t\t\t}," >> inch_mol_input.json	
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))
		fi

		node=$(echo $leaf1 | cut -d "_" -f2 | cut -d "\"" -f1)
		leaves=$(echo "$totalcount" | cut -d "," -f $node)
		count=$(($count+$leaves))
	fi

	if [[ $id =~ "\"node_1\"" ]]; then
		totalcount=$(echo "$count")
	else
		totalcount=$(echo "$totalcount,$count")
	fi
	#echo $totalcount

	height=$(echo $line | cut -d "," -f4 | cut -d "\"" -f2)

	if [[ $parentline =~ [0-9]+ ]]; then
		parent=$(head -n $parentline /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | tail -n 1 | cut -d "," -f1)
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"parent\": $parent,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}," >> inch_mol_input.json	
	else
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}" >> inch_mol_input.json	
	fi
	
	i=$(($i+1))
done

echo -en "\n\t\t}\t\n\t}\n}" >> inch_mol_input.json 
