#Author : Rieux Charlotte, University of Nantes, France
#!/usr/bin/env bash

##############################################################################
## HEATMAP COLUMNS ORDERING
##############################################################################

rownb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap2.csv | wc -l | cut -f1)
colnb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap2.csv | wc -l | cut -f1)
i=1

order=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/col_leaves_order.csv)

while [ $i -le $(($rownb-1)) ]; do

	cpd=$( echo $order | cut -d "," -f $i)
	#echo $cpd
	cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap2.csv | grep $cpd >> temp2.txt
	i=$(($i+1))

done 

cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap2.csv | tail -n 1 >> temp2.txt

sed -i 's/,/ /g' temp2.txt 

#cat temp2.txt

row=$(wc -l temp2.txt | cut -d " " -f 1)
column=$(head -n 1 temp2.txt | tail -n 1 | awk '{print NF}')
cat temp2.txt > "#temp2.txt#"
rm temp2.txt
i=1
j=0

while [ $i -le $column ]; do
	while [ $j -le $row ]; do
		value=$(head -n $j "#temp2.txt#" | tail -n 1 | awk '{print $'"$i"'}')
		echo -n "$value " >> temp2.txt
		j=$(($j+1))
	done
	echo "" >> temp2.txt
	j=0
	i=$(($i+1))
done

cat temp2.txt > /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv
sed -i 's/ /,/g' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv
sed -i -e 's/^.//' /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv
rm temp2.txt
rm "#temp2.txt#"

##############################################################################
## DATA
##############################################################################

rownb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | wc -l | cut -f1)
colnb=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | wc -l | cut -f1)
totalcount=""
i=2
leaf=1

echo -en "{\n\t\"data\" :{\n\n\t\t\"nodes\": {\n" > inch_pdb_input2.json

while [ $i -le $rownb ]; do 

	line=$(head -n $i /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | tail -n 1)
	#echo $line
	id=$(echo $line | cut -d "," -f1)
	#echo -e $id
	leaf1=$(echo $line | cut -d "," -f2)
	#echo $leaf1
	leaf2=$(echo $line | cut -d "," -f3)
	#echo $leaf2
	height=0
	#echo $height
	parentline=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | cut -d "," -f2,3 | grep -n $id | cut -d ":" -f1)
	#echo $parentline
	count=0

	if [[ $leaf1 =~ "leaf" ]]; then
		leaf=$(echo $leaf1 | cut -d "_" -f2 | cut -d "\"" -f1)
		#echo $leaf
		object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $(($leaf+1)) | tail -n 1)
		features=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | grep $object_id | cut -d "," -f -$colnb)
		#echo $features
		object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/PDB.csv | grep $object_id | cut -d "," -f 2)
		
		#If no PDB id, keeping Uniprot accession
		if [[ $object_id =~ "\"none\"" ]]; then
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $(($leaf+1)) | tail -n 1)
		fi
		
		#echo $object_id	

		echo -en "\n\t\t\t$leaf1: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"features\": [$features],\n\t\t\t\t\"parent\": $id,\n\t\t\t\t\"objects\": [$object_id]\n\t\t\t}," >> inch_pdb_input2.json	
		count=1

		if [[ $leaf2 =~ "leaf" ]]; then
			leaf=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $(($leaf+1)) | tail -n 1)
			features=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | grep $object_id | cut -d "," -f -$colnb)
			#echo $features
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/PDB.csv | grep $object_id | cut -d "," -f 2)
		
		#If no PDB id, keeping Uniprot accession
		if [[ $object_id =~ "\"none\"" ]]; then
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $(($leaf+1)) | tail -n 1)
		fi
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"features\": [$features],\n\t\t\t\t\"parent\": $id,\n\t\t\t\t\"objects\": [$object_id]\n\t\t\t}," >> inch_pdb_input2.json		
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))				
		fi

	else

		if [[ $leaf2 =~ "leaf" ]]; then
			leaf=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $(($leaf+1)) | tail -n 1)
			features=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | grep $object_id | cut -d "," -f -$colnb)
			#echo $features
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/PDB.csv | grep $object_id | cut -d "," -f 2)
		
		#If no PDB id, keeping Uniprot accession
		if [[ $object_id =~ "\"none\"" ]]; then
			object_id=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $(($leaf+1)) | tail -n 1)
		fi
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"features\": [$features],\n\t\t\t\t\"parent\": $id,\n\t\t\t\t\"objects\": [$object_id]\n\t\t\t}," >> inch_pdb_input2.json		
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))
		fi

		node=$(echo $leaf1 | cut -d "_" -f2 | cut -d "\"" -f1)
		leaves=$(echo "$totalcount" | cut -d "," -f $node)
		count=$(($count+$leaves))
	fi

	if [[ $id =~ "\"node_1\"" ]]; then
		totalcount=$(echo "$count")
	else
		totalcount=$(echo "$totalcount,$count")
	fi
	#echo $totalcount
	
	height=$(echo $line | cut -d "," -f4 | cut -d "\"" -f2)

	if [[ $parentline =~ [0-9]+ ]]; then
		parent=$(head -n $parentline /usr/lib/knime_2.9.2/workspace/drop/Tables/row_dendrogram.csv | tail -n 1 | cut -d "," -f1)
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"parent\": $parent,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}," >> inch_pdb_input2.json	
	else
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}" >> inch_pdb_input2.json	
	fi

	i=$(($i+1))
done

feature_names=$(head -n 1 /usr/lib/knime_2.9.2/workspace/drop/Tables/col_leaves_order.csv | tail -n 1)
echo -en "\n\t\t},\n\n\t\t\"feature_names\": [$feature_names]\n\t}," >> inch_pdb_input2.json

##############################################################################
## METADATA
##############################################################################

i=2
leaf=1

echo -en "\n\n\t\"metadata\": {\n\t\t\"feature_names\": [\"Families\"],\n\t\t\"nodes\": {" >> inch_pdb_input2.json

while [ $i -le $(($rownb+1)) ]; do 
	target=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/heatmap_pdb2.csv | cut -d "," -f $(($colnb+1)) | head -n $i | tail -n 1)
	#echo $target
	family=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/all_proteins_domains.csv | grep $target | cut -d "," -f 1)
	if [ $i -eq $(($rownb+1)) ]; then
		echo -en "\n\t\t\t\"leaf_$leaf\" : [$family]" >> inch_pdb_input2.json
	else
		echo -en "\n\t\t\t\"leaf_$leaf\" : [$family]," >> inch_pdb_input2.json
	fi
	leaf=$(($leaf+1))	
	i=$(($i+1))

done

echo -en "\n\t\t}\n\t}," >> inch_pdb_input2.json

##############################################################################
## COLUMN DENDROGRAM
##############################################################################

i=2
totalcount=""
echo -en "\n\n\t\"column_dendrogram\": {\n\t\t \"nodes\": {" >> inch_pdb_input2.json

while [ $i -le $colnb ]; do 

	line=$(head -n $i /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | tail -n 1)
	#echo $line
	id=$(echo $line | cut -d "," -f1)
	#echo -e $id
	leaf1=$(echo $line | cut -d "," -f2)
	#echo $leaf1
	leaf2=$(echo $line | cut -d "," -f3)
	#echo $leaf2
	height=0
	#echo $height
	parentline=$(cat /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | cut -d "," -f2,3 | grep -n $id | cut -d ":" -f1)
	#echo $parentline
	count=0

	if [[ $leaf1 =~ "leaf" ]]; then
		echo -en "\n\t\t\t$leaf1: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"parent\": $id \n\t\t\t}," >> inch_pdb_input2.json	
		count=1

		if [[ $leaf2 =~ "leaf" ]]; then
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"parent\": $id \n\t\t\t}," >> inch_pdb_input2.json	
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))				
		fi

	else

		if [[ $leaf2 =~ "leaf" ]]; then
			echo -en "\n\t\t\t$leaf2: {\n\t\t\t\t\"count\": 1,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"parent\": $id \n\t\t\t}," >> inch_pdb_input2.json	
			count=$(($count+1))
		
		else
			node=$(echo $leaf2 | cut -d "_" -f2 | cut -d "\"" -f1)
			leaves=$(echo "$totalcount" | cut -d "," -f $node)
			count=$(($count+$leaves))
		fi

		node=$(echo $leaf1 | cut -d "_" -f2 | cut -d "\"" -f1)
		leaves=$(echo "$totalcount" | cut -d "," -f $node)
		count=$(($count+$leaves))
	fi

	if [[ $id =~ "\"node_1\"" ]]; then
		totalcount=$(echo "$count")
	else
		totalcount=$(echo "$totalcount,$count")
	fi
	#echo $totalcount

	height=$(echo $line | cut -d "," -f4 | cut -d "\"" -f2)

	if [[ $parentline =~ [0-9]+ ]]; then
		parent=$(head -n $parentline /usr/lib/knime_2.9.2/workspace/drop/Tables/col_dendrogram.csv | tail -n 1 | cut -d "," -f1)
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"parent\": $parent,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}," >> inch_pdb_input2.json	
	else
		echo -en "\n\t\t\t$id: {\n\t\t\t\t\"count\": $count,\n\t\t\t\t\"distance\": $height,\n\t\t\t\t\"left_child\": $leaf1,\n\t\t\t\t\"right_child\": $leaf2\n\t\t\t}" >> inch_pdb_input2.json	
	fi
	
	i=$(($i+1))
done

echo -en "\n\t\t}\t\n\t}\n}" >> inch_pdb_input2.json 
